# Generated by Django 5.1.2 on 2024-11-01 15:08

from django.db import migrations, models

# Once GraphModel.create_node_alias is a static method, we can remove this import.
# Until then, this is safe to use in a migration, because it doesn't use Graph
# fields (and thus is a lot like a static method).
from arches.app.models.graph import Graph


class Migration(migrations.Migration):

    dependencies = [
        ("models", "11042_update__arches_staging_to_tile"),
    ]

    def create_node_aliases(apps, schema_editor):
        Node = apps.get_model("models", "Node")
        nodes_needing_alias = Node.objects.filter(alias__isnull=True)
        for node in nodes_needing_alias:
            Graph.objects.get(pk=node.graph_id).create_node_alias(node)
        Node.objects.bulk_update(nodes_needing_alias, ["alias"])

    operations = [
        migrations.RunPython(create_node_aliases, migrations.RunPython.noop),
        migrations.AlterField(
            model_name="node",
            name="alias",
            field=models.TextField(blank=True),
        ),
    ]
